#include "XATICATypes.h"
#ifdef __cplusplus
 extern "C" {
 #endif
	/** ********************** INDEPENDENT CP  *************************** */

	/* SJC */

int restartJobInitUC(const char* __jobId,const char* __userCert, int* returnValue);




int checkpointJobInit(const char* __jobId,int __resolveJobDependencies,const char* __modeType,const char* __options,const char* __userCert, int* returnValue);


	/** JOB CHECKPOINTER (JC)
	 * know job units
	 * mJUC entry (job-unit address and state ) 
	 * select appropriate kernel checkpointer
	 */

int returnFromJobLocking(const char* __jobId,const char* __initialJobId,const char* __jsdlFile,const char* __executable,const ArrayListCA __jobUnitAddresses,const CommunicationAddress __superJobCpAddr,const ArrayList __dependentJobs,const char* __strategy,const char* __options,const char* __mode,int __ret,const char* __userCert );


	/************************** RESTART *********************************
	 * 
	 * 
	 * 
	 * 
	 * 
	 ******************************************************************* /
	 
	/*
	 * put ip- and port-details into required format for further computation
	 * 
	 * In MIGRATION context at least one destination address of one job-unit is known
	 * FAULT TOLERANCE context, destination addresses are not knwon => getResources must
	 * be executed for ALL job-units */

int restartJobInit(const char* __jobId,const char* __checkpointVersion,int __restartDependentJobs,const ArrayList __ip,const ArrayList __port,const char* __mode,const char* __userCert, int* returnValue);




int prepResReallocation(const char* __jobId,const char* __checkpointVersion,int __restartDependentJobs,const char* __desiredRestartDestination,const char* __mode,const char* __userCert );


	/**BEST SERVICE! - used!
	 * FEATURE: find matching nodes by regarding kernel checkpointer and potential resource(PID,IPC) conflicts, 
	 * DRAWBACK: unknown number of repeatedly called 'getResources' (worst case: it will never stop => upper limit)
	 */

int matchUnitsBiggerNodesCB(const ArrayListCA __list );




int proceedWithRebuilding(const char* __jobId,const char* __initialJobId );




int proceedWithResumingRST(const char* __jobId,const char* __initialJobId );




int terminateSingleMultiJobRestart(const char* __jobId,const char* __initialJobId );


#ifdef __cplusplus 
 } 
 #endif 
