#include "XATICATypes.h"
#ifdef __cplusplus
 extern "C" {
 #endif
	/**
	 * This method is used for pushing Vivaldi coordintes into the DHT
	 * @param X x coordinate
	 * @param Y y coordinates
	 * @param IP the IP of the machine
	 * @return null 
	 * @throws Exception
	 */
/* TODO
 * Unimplemented parameter type: java.lang.Double
 *//* TODO
 * Unimplemented parameter type: java.lang.Double
 *//* TODO
 * Unimplemented parameter type: java.net.InetAddress
 */
int pushingVivaldiCoordinates( int* returnValue);




int pushMDinfo(const char* __Info );




int retrieveMDinfo(const char* __Query, char** returnValue);




int resourceQuery(const char* __jsdlDocument,const char* __xacmlDocument,const char* __userXOSDCert,int __howmany, char** returnValue);


	/**
	 * Stores informations about a JOB
	 * @param jobID the jod unique ID
	 * @param {@Link CommunicationAddress} jobManag the associated Job Manager 
	 * @param userID the ID (unique) of the User that launched the job
	 * @return
	 * @throws Exception
	 */

int putJob(const char* __jobID,const CommunicationAddress __jobManag,const char* __userID, int* returnValue);




int getJobContactPoint(const char* __jobID, CommunicationAddress* returnValue);


	/**
	 * Removes a communication address (not yet really implemented)
	 * @param nodeToRemove the Communication address of the node to remove
	 * @return null
	 * @throws Exception
	 */

int removeResource(const CommunicationAddress __nodeToRemove, int* returnValue);




int modifyJobContactPoint(const char* __jobID,const CommunicationAddress __newAddress, int* returnValue);


	/**
	 * Adds a new attribute to the job
	 * @param jobID the job's ID
	 * @param attribute {@link ADSAttribute} the new attribute
	 * @return null
	 * @throws Exception
	 */
/* TODO
 * Unimplemented parameter type: eu.xtreemos.xosd.srdsmng.base.ADSAttribute
 */
int setAttribute(const char* __jobID, int* returnValue);


	/**
	 * Removes a Job 
	 * @param jobID the job's ID
	 * @return null
	 * @throws Exception
	 */

int removeJob(const char* __jobID, int* returnValue);


	/**
	 * Retrieves the value of a job's attribute
	 * @param jobID the job's ID
	 * @param attributeName The name of the attribute
	 * @return
	 */

int getJobAttribute(const char* __jobID,const char* __attributeName, char** returnValue);


	/**
	 * Returns a {@link ArrayList} list of Jobs that fit the (name,value) couple of the attribute submitted
	 * @param {@Link ADSAttribute} attribute 
	 * @return null
	 */
/* TODO
 * Unimplemented parameter type: eu.xtreemos.xosd.srdsmng.base.ADSAttribute
 */
int getJobsByAttribute( ArrayList* returnValue);


	/**
	 * Removes the attribute associated to the job 
	 * @param jobID the job's ID 
	 * @param attrName the name of the attribute 
	 * @return
	 */

int removeJobAttribute(const char* __jobID,const char* __attrName, int* returnValue);


	/**
	 * Tool that stops SRDS
	 * @param {@link X509Certificate} userXOSDCert 
	 * @return null
	 */

int stopSRDS(const char* __userXOSDCert, int* returnValue);


	/**
	 * Method for starting SRDS
	 * @param userXOSDCert user certificates
	 * @param args Argument passed to main method
	 * @return
	 */

int startSRDS(const char* __userXOSDCert,const ArrayList __args, int* returnValue);


#ifdef __cplusplus 
 } 
 #endif 
