#ifdef __cplusplus
extern "C" {
#endif

#ifndef XATIC_COMM_INCLUDED
#define XATIC_COMM_INCLUDED


/* Define length of the socket buffer */
#define SOCK_MAX_BUF 80000
/* Define the length of the buffer that will have the XML send to XOSD*/
#define SEND_XML_BUF 100000
/* Define port numbers for sockets */
#define COMM_CLIENT_PORT 46000
/* Number of seconds to wait for a response */
#define TIMEOUT 15
int send_command(char *message,int * status, void ** returnValue);

void* listenForReply(void *);
int parseReturnValue();
int getReply(int * status, void ** returnValue);
int	xml_wrapper(const char *orig, char **dest);

#endif
 #ifdef __cplusplus
 }
 #endif
